
\ 12-bit ADC using internal ADC12 of MSP430FR5xxx
: ADC-ON    ( -- )
    02 800 **bic            \ ADC12CTL0  Clear ENC
    37 20A *bis             \ P1SEL0     P1.4 = ADC in  (37 see below)
    37 20C *bis             \ P1SEL1     (37=P1.0, P1.1, P1.2, P1.4 & P1.5)
    06 22A *bis             \ P3SEL0     (P3.1, P3.2)
    06 22C *bis             \ P3SEL1
    31 1B0 !                \ REFCTL0    Activate VREF at 2.5 Volt
    0410 800 !              \ ADC12CTL0  Sampletime 64 clocks, ADC on
    2200 802 !              \ ADC12CTL1  Clock/4, use sample timer
    0020 804 !              \ ADC12CTL2  12 bit resolution
    02 800 **bis ;          \ ADC12CTL0  Set ENC

\ We need to clear the ENC bit before setting a new input channel
\ ADC can be used with VCC and VREF (2.5V) as reference voltage
: ADC       ( +n fl -- u )
    02 800 **bic            \ ADC12CTL0  Clear ENC
    100 and >r              \ Use VREF when fl is true
    1F and  r> or 820 !     \ ADC12MCTL0 Select input
    03 800 **bis            \ ADC12CTL0  Set ENC & ADC12SC
    begin 1 802 bit** 0= until \ ADC12CTL1  ADC12 busy?
    860 @ ;                 \ ADC12MEM0  Read result

: ACCU          04 -1 adc ; \ Read accu level at P1.4 using VREF
: REFLECTION    0 adc ;     \ Read sensor level at Ax using VCC

\ End
